      subroutine cpi4(n,x,y)
c     ------------------------------------------------------------------
c
c     cpi4:  Copy the n-dimensional array x 
c            into the n-dimensional array y
c
c     ------------------------------------------------------------------
c
c     Passed input scalar:
c
c          n   - array dimension
c
c     ------------------------------------------------------------------
      implicit   none
      integer n

c     ------------------------------------------------------------------
c
c     Passed input array:
c    
c          x   - array to be copied 
c
c     ------------------------------------------------------------------
      integer x(n)

c     ------------------------------------------------------------------
c
c     Passed output array:
c    
c          y   - copy array  
c
c     ------------------------------------------------------------------
      integer y(n)

c     ------------------------------------------------------------------
c
c     Local scalar:
c    
c          i      - do loop index
c    
c     ------------------------------------------------------------------
      integer i

c     ------------------------------------------------------------------
      do 10 i=1,n
           y(i)=x(i)
10    continue
      return
c
c     ------------------------------------------------------------------
c     End of subroutine cpi4.
c     ------------------------------------------------------------------
c
      end
