      subroutine genkn(nv,k,x,nindex,xn,seedn)
c     ------------------------------------------------------------------
c     genkn: given a 0-1 array x, find at random a k-neighbor
c            of x and call it xn
c     ------------------------------------------------------------------
      integer nv,k,seedn
      integer x(nv),xn(nv),nindex(nv)
      integer i,j,icount,index,nava
      real    randp,xrand
c     ------------------------------------------------------------------
c     initialize nindex to 0,0,...,0      
c     ------------------------------------------------------------------
      do 10 i=1,nv
           nindex(i)=0
           xn(i)=x(i)
10    continue

c     ------------------------------------------------------------------
c     main loop: generate k distinct & independent indices to be flipped
c     ------------------------------------------------------------------
      do 20 i=1,k
           xrand=randp(seedn)
           nava=nv-i+1
           index=1+seedn/(2147483647/nava)
           icount=0
           do 30 j=1,nv
                if (nindex(j).eq.0) then
                     icount=icount+1
                     if (icount.eq.index) then
                          nindex(j)=1
                          if (x(j).eq.1) then
                               xn(j)=0
                          else
                               xn(j)=1
                          endif
                          goto 20
                     endif
                endif
30         continue
20    continue
c     ------------------------------------------------------------------
      return
      end
