       subroutine initpr (ne,n2e,nv,optz,objf,S,nS,
     +                    first,edge,next,sums,sumsb,v,w,target,
     +                    x,y,tmpx,ntmpx,tmpy,ntmpy, nmxelt,nmelt,
     +                    felt,velt,nxtelt,objelt,objt,tmpS,ntmpS,
     +                    tobjf,ndiff,symdif)
      implicit none

c     ------------------------------------------------------------------
c     (Re)Initializes Path relinking.
c     ------------------------------------------------------------------

c     ------------------------------------------------------------------
c     Passed variables:
c     ------------------------------------------------------------------  
      integer ne,n2e,nv,optz,objf
      integer S(nv),nS
      integer first(nv),edge(n2e),next(n2e)
      integer sums(nv),sumsb(nv),v(n2e),w(ne)
      integer target
      integer x(nv),y(nv)
      integer tmpx(nv),ntmpx,tmpy(nv),ntmpy
      integer nmxelt,nmelt
      integer felt(nmxelt),velt(nmelt),
     +         nxtelt(nmelt),objelt(nmxelt)  
      integer objt
      integer tmpS(nv),ntmpS,tobjf
      integer ndiff,symdif(nv)


c     ------------------------------------------------------------------
c     Local variables:
c     ------------------------------------------------------------------ 
      integer i,node, ptr
c     ------------------------------------------------------------------ 

c     ------------------------------------------------------------------
c     Recover (nS,S) from (ntmpS,tmpS)
c     ------------------------------------------------------------------
      call cpi4(ntmpS,tmpS,S)
      nS=ntmpS
      objf=tobjf

      
c     ------------------------------------------------------------------
c     Compute symmetric difference between S and target.
c     ------------------------------------------------------------------
      do 10 i=1,nv
           x(i)=0
           y(i)=0
10    continue
      do 20 i=1,nS
           x(S(i))=1
20    continue
      ntmpx=0
      ptr=felt(target)
30    if (ptr .eq. 0) goto 40
           y(velt(ptr))=1
c
c          save target in (ntmpx,tmpx)
c
	   ntmpx=ntmpx+1
	   tmpx(ntmpx)=velt(ptr)
           ptr=nxtelt(ptr)
	   goto 30
40    continue
      
      objt=objelt(target)

c     ------------------------------------------------------------------
c     Compute symmetric difference between S and target elite solution.
c     ------------------------------------------------------------------
      ndiff=0
      ntmpy=0
      do 50 i=1,nv
           if (x(i).ne.y(i)) then
	        ndiff=ndiff+1
		symdif(ndiff)=i
c               save symdif in (ntmpy,tmpy)
                ntmpy=ntmpy+1
		tmpy(ntmpy)=i
           endif
50    continue


      return
      end


