      integer function ndiff(index,nS,nmelt,nmxelt,nv,S,velt,felt,
     +                       nxtelt,xdiff,ydiff)
c     ------------------------------------------------------------------
c     ndiff: Integer function that returns the distance between two
c            node sets: S and Elite set indexed by index.
c     ------------------------------------------------------------------
      implicit none
      integer index,nS,nmxelt,nv,nmelt,i,ptr
      integer S(nv),felt(nmxelt),nxtelt(nmelt),velt(nmelt)
      integer xdiff(nv),ydiff(nv)

      do 10 i=1,nv
           xdiff(i)=0
           ydiff(i)=0
10    continue
      
      do 20 i=1,nS
           xdiff(S(i))=1
20    continue

      ptr=felt(index)
30    if (ptr .eq. 0) goto 40
           ydiff(velt(ptr))=1
           ptr=nxtelt(ptr)
	   goto 30
40    continue

      ndiff=0
      do 50 i=1,nv
           if (xdiff(i).ne.ydiff(i)) ndiff=ndiff+1
50    continue
      
      return
      end
