      subroutine upddeg(edge,first,ne,n2e,next,
     +                   node,nv,sums,sumsb,v,vertex,w)
c     ------------------------------------------------------------------
c     upddeg: Update weighted degrees.
c     ------------------------------------------------------------------
      implicit none

      integer ne,n2e,nv,node
      integer edge(n2e),first(nv),
     +        next(n2e),
     +        sums(nv),sumsb(nv),v(n2e),
     +        vertex(nv),w(ne)

      integer e,u
c     ------------------------------------------------------------------
      e=first(node)
10    if (e.eq.0) goto 20
           u=v(e)
           if (vertex(node).eq.1) then
                sums(u)=sums(u)+w(edge(e))
           else
                sumsb(u)=sumsb(u)+w(edge(e))
           endif
           e=next(e)
           goto 10
20    continue
      
      return

c     ------------------------------------------------------------------
c     End of subroutine upddeg.
c     ------------------------------------------------------------------
      end
